#include "QuProlog.h"

extern "C" long p_stat(char *, long*, long*, long*, long*, long*, long*, long*, long*, long*, long*, long*, long*, long*);
extern "C" long p_unlink(char *);
extern "C" long p_mkdir(char *, long);
extern "C" char * p_error(long);
extern "C" long ctr_alloc(long);
extern "C" long ctr_get(long);
extern "C" void ctr_set(long, long);
extern "C" long p_getpid(void);
extern "C" long p_opendir(char *, long*, long*);
extern "C" long p_readdir(long, long, long*, char **);
extern "C" void p_closedir(long, long);

extern "C" bool
p_stat_interface(ForeignInterface* fi)
{
 bool result = true;
 char * atom0;
 long integer1;
 long integer2;
 long integer3;
 long integer4;
 long integer5;
 long integer6;
 long integer7;
 long integer8;
 long integer9;
 long integer10;
 long integer11;
 long integer12;
 long integer13;
 long integer14;
 Object* object0;
 Object* object1;
 Object* object2;
 Object* object3;
 Object* object4;
 Object* object5;
 Object* object6;
 Object* object7;
 Object* object8;
 Object* object9;
 Object* object10;
 Object* object11;
 Object* object12;
 Object* object13;
 Object* object14;
 Object* outarg1;
 Object* outarg2;
 Object* outarg3;
 Object* outarg4;
 Object* outarg5;
 Object* outarg6;
 Object* outarg7;
 Object* outarg8;
 Object* outarg9;
 Object* outarg10;
 Object* outarg11;
 Object* outarg12;
 Object* outarg13;
 Object* outarg14;

 object0 = fi->getXReg(0);
 if (!object0->isAtom())
 {
  return(false);
 }
 atom0 = fi->getAtomString(object0);
 object1 = fi->getXReg(1);
 object2 = fi->getXReg(2);
 object3 = fi->getXReg(3);
 object4 = fi->getXReg(4);
 object5 = fi->getXReg(5);
 object6 = fi->getXReg(6);
 object7 = fi->getXReg(7);
 object8 = fi->getXReg(8);
 object9 = fi->getXReg(9);
 object10 = fi->getXReg(10);
 object11 = fi->getXReg(11);
 object12 = fi->getXReg(12);
 object13 = fi->getXReg(13);

 object14 = fi->getXReg(14);

 integer14 = p_stat(atom0, &integer1, &integer2, &integer3, &integer4, &integer5, &integer6, &integer7, &integer8, &integer9, &integer10, &integer11, &integer12, &integer13);

 outarg1 = fi->makeInteger(integer1);
 result = result && fi->unify(object1, outarg1);
 outarg2 = fi->makeInteger(integer2);
 result = result && fi->unify(object2, outarg2);
 outarg3 = fi->makeInteger(integer3);
 result = result && fi->unify(object3, outarg3);
 outarg4 = fi->makeInteger(integer4);
 result = result && fi->unify(object4, outarg4);
 outarg5 = fi->makeInteger(integer5);
 result = result && fi->unify(object5, outarg5);
 outarg6 = fi->makeInteger(integer6);
 result = result && fi->unify(object6, outarg6);
 outarg7 = fi->makeInteger(integer7);
 result = result && fi->unify(object7, outarg7);
 outarg8 = fi->makeInteger(integer8);
 result = result && fi->unify(object8, outarg8);
 outarg9 = fi->makeInteger(integer9);
 result = result && fi->unify(object9, outarg9);
 outarg10 = fi->makeInteger(integer10);
 result = result && fi->unify(object10, outarg10);
 outarg11 = fi->makeInteger(integer11);
 result = result && fi->unify(object11, outarg11);
 outarg12 = fi->makeInteger(integer12);
 result = result && fi->unify(object12, outarg12);
 outarg13 = fi->makeInteger(integer13);
 result = result && fi->unify(object13, outarg13);
 outarg14 = fi->makeInteger(integer14);
 result = result && fi->unify(object14, outarg14);

 return(result);
}

extern "C" bool
p_unlink_interface(ForeignInterface* fi)
{
 bool result = true;
 char * atom0;
 long integer1;
 Object* object0;
 Object* object1;
 Object* outarg1;

 object0 = fi->getXReg(0);
 if (!object0->isAtom())
 {
  return(false);
 }
 atom0 = fi->getAtomString(object0);

 object1 = fi->getXReg(1);

 integer1 = p_unlink(atom0);

 outarg1 = fi->makeInteger(integer1);
 result = result && fi->unify(object1, outarg1);

 return(result);
}

extern "C" bool
p_mkdir_interface(ForeignInterface* fi)
{
 bool result = true;
 char * atom0;
 long integer1;
 long integer2;
 Object* object0;
 Object* object1;
 Object* object2;
 Object* outarg2;

 object0 = fi->getXReg(0);
 if (!object0->isAtom())
 {
  return(false);
 }
 atom0 = fi->getAtomString(object0);
 object1 = fi->getXReg(1);
 if (!object1->isInteger())
 {
  return(false);
 }
 integer1 = object1->getInteger();

 object2 = fi->getXReg(2);

 integer2 = p_mkdir(atom0, integer1);

 outarg2 = fi->makeInteger(integer2);
 result = result && fi->unify(object2, outarg2);

 return(result);
}

extern "C" bool
p_error_interface(ForeignInterface* fi)
{
 bool result = true;
 long integer0;
 char * atom1;
 Object* object0;
 Object* object1;
 Object* outarg1;

 object0 = fi->getXReg(0);
 if (!object0->isInteger())
 {
  return(false);
 }
 integer0 = object0->getInteger();

 object1 = fi->getXReg(1);

 atom1 = p_error(integer0);

 outarg1 = fi->makeAtom(atom1);
 result = result && fi->unify(object1, outarg1);

 return(result);
}

extern "C" bool
ctr_alloc_interface(ForeignInterface* fi)
{
 bool result = true;
 long integer0;
 long integer1;
 Object* object0;
 Object* object1;
 Object* outarg1;

 object0 = fi->getXReg(0);
 if (!object0->isInteger())
 {
  return(false);
 }
 integer0 = object0->getInteger();

 object1 = fi->getXReg(1);

 integer1 = ctr_alloc(integer0);

 outarg1 = fi->makeInteger(integer1);
 result = result && fi->unify(object1, outarg1);

 return(result);
}

extern "C" bool
ctr_get_interface(ForeignInterface* fi)
{
 bool result = true;
 long integer0;
 long integer1;
 Object* object0;
 Object* object1;
 Object* outarg1;

 object0 = fi->getXReg(0);
 if (!object0->isInteger())
 {
  return(false);
 }
 integer0 = object0->getInteger();

 object1 = fi->getXReg(1);

 integer1 = ctr_get(integer0);

 outarg1 = fi->makeInteger(integer1);
 result = result && fi->unify(object1, outarg1);

 return(result);
}

extern "C" bool
ctr_set_interface(ForeignInterface* fi)
{
 bool result = true;
 long integer0;
 long integer1;
 Object* object0;
 Object* object1;

 object0 = fi->getXReg(0);
 if (!object0->isInteger())
 {
  return(false);
 }
 integer0 = object0->getInteger();
 object1 = fi->getXReg(1);
 if (!object1->isInteger())
 {
  return(false);
 }
 integer1 = object1->getInteger();


 ctr_set(integer0, integer1);


 return(result);
}


extern "C" bool
p_getpid_interface(ForeignInterface* fi)
{
 bool result = true;
 long integer0;
 Object* object0;
 Object* outarg0;


 object0 = fi->getXReg(0);

 integer0 = p_getpid();

 outarg0 = fi->makeInteger(integer0);
 result = result && fi->unify(object0, outarg0);

 return(result);
}

extern "C" bool
p_opendir_interface(ForeignInterface* fi)
{
 bool result = true;
 char * atom0;
 long integer1;
 long integer2;
 long integer3;
 Object* object0;
 Object* object1;
 Object* object2;
 Object* object3;
 Object* outarg1;
 Object* outarg2;
 Object* outarg3;

 object0 = fi->getXReg(0);
 if (!object0->isAtom())
 {
  return(false);
 }
 atom0 = fi->getAtomString(object0);
 object1 = fi->getXReg(1);
 object2 = fi->getXReg(2);

 object3 = fi->getXReg(3);

 integer3 = p_opendir(atom0, &integer1, &integer2);

 outarg1 = fi->makeInteger(integer1);
 result = result && fi->unify(object1, outarg1);
 outarg2 = fi->makeInteger(integer2);
 result = result && fi->unify(object2, outarg2);
 outarg3 = fi->makeInteger(integer3);
 result = result && fi->unify(object3, outarg3);

 return(result);
}

extern "C" bool
p_readdir_interface(ForeignInterface* fi)
{
 bool result = true;
 long integer0;
 long integer1;
 long integer2;
 char * atom3;
 long integer4;
 Object* object0;
 Object* object1;
 Object* object2;
 Object* object3;
 Object* object4;
 Object* outarg2;
 Object* outarg3;
 Object* outarg4;

 object0 = fi->getXReg(0);
 if (!object0->isInteger())
 {
  return(false);
 }
 integer0 = object0->getInteger();
 object1 = fi->getXReg(1);
 if (!object1->isInteger())
 {
  return(false);
 }
 integer1 = object1->getInteger();
 object2 = fi->getXReg(2);
 object3 = fi->getXReg(3);

 object4 = fi->getXReg(4);

 integer4 = p_readdir(integer0, integer1, &integer2, &atom3);

 outarg2 = fi->makeInteger(integer2);
 result = result && fi->unify(object2, outarg2);
 outarg3 = fi->makeAtom(atom3);
 result = result && fi->unify(object3, outarg3);
 outarg4 = fi->makeInteger(integer4);
 result = result && fi->unify(object4, outarg4);

 return(result);
}

extern "C" bool
p_closedir_interface(ForeignInterface* fi)
{
 bool result = true;
 long integer0;
 long integer1;
 Object* object0;
 Object* object1;

 object0 = fi->getXReg(0);
 if (!object0->isInteger())
 {
  return(false);
 }
 integer0 = object0->getInteger();
 object1 = fi->getXReg(1);
 if (!object1->isInteger())
 {
  return(false);
 }
 integer1 = object1->getInteger();


 p_closedir(integer0, integer1);


 return(result);
}
